module JH
  module DCTestExample
    unless defined?(JH::DCTestExample.main)
      UI.menu.add_item('JH DC Test') { main }
    end

    def self.main
      # set the component dictionary
      @component_dictionary = 'dynamic_attributes'

      # First prompt for the dimensions. This is done using the inputbox
      # method. In this case, we will actually use a wrapper for UI.inputbox
      # that is defined in sketchup.rb which does some extra error checking
      # The first step is to create some arrays which contain the prompts
      # and default values.

      prompts = %w(Bemerkung Artikel Laenge Breite Staerke Kante_links
                   Kante_rechts Kante_oben Kante_unten Belag_Vorn Belag_hinten)
      values = ['BodenDecke', 'Material1', 600.mm, 400.mm, 19.mm, 'Kante1',
                'Kante1', '', '', '', '']
      list = ['', 'Material1|Material2|Material3|Material4|Material5|Material6',
              '', '', '',
              '|Kante1|Kante2|Kante3|Kante4|Kante5|Kante6',
              '|Kante1|Kante2|Kante3|Kante4|Kante5|Kante6',
              '|Kante1|Kante2|Kante3|Kante4|Kante5|Kante6',
              '|Kante1|Kante2|Kante3|Kante4|Kante5|Kante6',
              '|Belag1|Belag2|Belag3|Belag4|Belag5|Belag6',
              '|Belag1|Belag2|Belag3|Belag4|Belag5|Belag6']

      results = UI.inputbox(prompts, values, list, 'Boden')
      return unless results

      laenge = results[2]
      breite = results[3]
      staerke = results[4]

      comp1_def_instance = Sketchup.active_model.selection[0]
      comp1_def = comp1_def_instance

      comp1_def.definition.set_attribute(@component_dictionary, '_lenx_formula', laenge.to_s)
      comp1_def.definition.set_attribute(@component_dictionary, '_lenx_label', 'LenX')
      
      comp1_def.definition.set_attribute(@component_dictionary, '_leny_formula', breite.to_s)
      comp1_def.definition.set_attribute(@component_dictionary, '_leny_label', 'LenY')
      

      comp1_def.definition.set_attribute(@component_dictionary, '_lenz_formula', staerke.to_s)
      comp1_def.definition.set_attribute(@component_dictionary, '_lenz_label', 'LenZ')
      
      $dc_observers.get_latest_class.redraw_with_undo(comp1_def_instance)
    end
  end
end
